//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DimGray
#property indicator_color4  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property strict

extern string TimeFrame    = "Current time frame";  // Time frame to use
extern int    SmoothPeriod = 14;                    // smoothing period
extern bool   Interpolate  = true;                  // Interpolate in multi time frame mode

//
//
//
//
//

double bb[];
double bs[];
double vols[];
double volb[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, bs); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, bb); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, vols);
   SetIndexBuffer(3, volb);
            timeFrame         = stringToTimeFrame(TimeFrame);
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame=="returnBars";  if (returnBars) return(0);

     IndicatorShortName(timeFrameToString(timeFrame)+" Buy Sell presure volume ["+(string)SmoothPeriod+"]");
   return(0);
}

//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bs[0] = MathMin(limit+1,Bars-1); return(0); }
         if (timeFrame!=Period())
         {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);
                     bs[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",SmoothPeriod,0,y);
                     bb[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",SmoothPeriod,1,y);
                     vols[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SmoothPeriod,2,y);
                     volb[i] = iCustom(NULL,timeFrame,indicatorFileName,"",SmoothPeriod,3,y);
                     if (!Interpolate || (y!=0 && y==iBarShift(NULL,timeFrame,Time[MathMax(i-1,0)]))) continue;

                     //
                     //
                     //
                     //
                     //

                     int n,k;
                     datetime time = iTime(NULL,timeFrame,y);
                        for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
                        for(k = 1; k < n && (i+n)<Bars && (i+k)<Bars; k++) 
                        {
                           vols[i+k] = vols[i] + (vols[i+n] - vols[i]) * k/n;
                           volb[i+k] = volb[i] + (volb[i+n] - volb[i]) * k/n;
                           if (bs[i]!=EMPTY_VALUE) bs[i+k] = vols[i+k];
                           if (bb[i]!=EMPTY_VALUE) bb[i+k] = volb[i+k];
                        }                           
            }
            return(0);
         }

   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0 + SmoothPeriod);
      for(int i=limit; i>=0; i--)
      {
         if (i>=Bars-1) { volb[i] = 0;  vols[i] = 0;  continue;}
         double volume = 0; 
            if (Close[i]>iMA(NULL,0,SmoothPeriod,0,MODE_SMA,PRICE_CLOSE,i)) volume = (double) Volume[i];
            if (Close[i]<iMA(NULL,0,SmoothPeriod,0,MODE_SMA,PRICE_CLOSE,i)) volume = (double)-Volume[i];
            
      
            bb[i] = EMPTY_VALUE;
            bs[i] = EMPTY_VALUE;
            if (volume>0) 
                  { volb[i] = volb[i+1]+alpha*(volume-volb[i+1]); bb[i] = volb[i]; }
            else  { volb[i] = volb[i+1]; }
            if (volume<0)
                  { vols[i] = vols[i+1]+alpha*(volume-vols[i+1]); bs[i] = vols[i]; }
            else  { vols[i] = vols[i+1]; }
      }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}